<?php

/* compose.php: Page for creating and sending messages
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: compose.php,v 1.266 2006/01/19 21:29:11 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'compose');

/* set ini values and check/get the SESSION vars */
$clear = false;
if (isset($hm_input['new']) && $hm_input['new'] == 1) {
    $clear = true;
}
if (hm_session_continue($hm_input['id'], $config_file, $clear)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config, 
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get contacts */
if (isset($hm_input['search_terms']) && $hm_input['search_terms'] != '' && 
    !isset($hm_input['list'])) {
    $search = $hm_input['search_terms'];
    $search_terms = hm_htmlize($search);
}
else {
    $search = false;
    $search_terms = '';
}
$contacts = hmw_get_contacts($_SESSION['user'], $config, $hasty_key, $search, true, true);

/* check for alt SMTP auth option */
$alt_spass = false;
if (isset($hm_input['alt_spass']) && $hm_input['alt_spass'] != '') {
    $_SESSION['alt_spass'] = hmw_crypt($hm_input['alt_spass'], $config, 'encrypt',
                               $hasty_key);
    $alt_spass = true;
}
elseif (isset($_SESSION['alt_spass'])) {
    $alt_spass = true;
}

/* set field values for a reply or forward */
if (isset($hm_input['reply']) || isset($hm_input['forward']) ||
    isset($hm_input['draft']) || isset($hm_input['bounce'])) {
    hm_select_mailbox($imap_stream, $hm_input['mailbox']);
    if (isset($hm_input['part']) && $hm_input['part'] != 1) {
        $structure_temp = hm_get_struct($imap_stream, $hm_input['uid']);
        $structure = &hm_in_multi_array($hm_input['part'], $structure_temp, array(),
                     true);
        if ($structure && $structure[0] != '') {
            $parent_part = $structure[0];
            $structure[0] = $structure[1];
            unset($structure[1]);
        }
        else {
            $structure = $structure_temp;
            $parent_part = false;
        }
    }
    else {
        $structure = hm_get_struct($imap_stream, $hm_input['uid']);
        $parent_part = false;
        $hm_input['part'] = 1;
    }
    /* reply formatting */
    if (isset($hm_input['reply'])) {
        if ((isset($structure[$hm_input['part']]['subtype']) &&
            $structure[$hm_input['part']]['subtype'] == 'html') ||
            (isset($structure[0]['subs'][$hm_input['part']]['subtype']) &&
            $structure[0]['subs'][$hm_input['part']]['subtype'] == 'html')) {
            $get_part = $hm_input['part'];
            $html = true;
        }
        elseif (isset($structure[$hm_input['part']]['type']) &&
            $structure[$hm_input['part']]['type'] == 'text' ||
            (isset($structure[0]['subs'][$hm_input['part']]['type']) &&
            $structure[0]['subs'][$hm_input['part']]['subtype'] == 'text')) {
            $get_part = $hm_input['part'];
            $html = false;
        }
        else {
            $get_part = false;
            $html = false;
        }
        $result = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                       $get_part, true, true);
        if ($html) {
            $result[1] = str_replace(array("\n", '</td>', '&nbsp;', '&gt;', '&lt;'),
                                     array('', ' ', ' ', '>', '<'), $result[1]);
            $result[1] = "\n".strip_tags(str_replace(
                                     array('<br>', '</th>', '</tr>', '</li>', '</ul>',
                                           '<BR>', '</TH>', '</TR>', '</LI>', '</UL>',
                                           '</DIV>',  '</div>'),
                                     "\n", $result[1]));
            $result[1] = &hm_text_cleanup($result[1], true, true);
        }
        $hm_input['part'] = $result[0];

        /* setup charset mechanism */
        $charset = 'us-ascii';
        $code_page = array();
        if (isset($result[2][4])) {
            $charset = strtolower($result[2][4]);
            if (isset($_SESSION['charsets'][$charset])) {
                $code_page = $_SESSION['charsets'][$charset];
            }
        }
        $message = hm_special_chars2($result[1], $charset, $code_page);

        /* checking for list reply */
        $headers = hm_get_full_header($imap_stream, $hm_input['uid'], $parent_part);
        if (!isset($hm_input['list_reply'])) {
            if (isset($headers['reply-to'])) {
                $to = stripslashes($headers['reply-to']);
            }
            elseif (isset($headers['from'])) {
                $to = stripslashes($headers['from']);
            }
            else {
                $to = '';
            }
        }
        else {
            $to = $hm_input['list_reply'];
        }
        if (isset($headers['from']) && strstr($headers['from'], $to)) {
            $to = $headers['from'];
        }
        
        /* reply quote line */
        if (isset($headers['date'])) {
            if (isset($_SESSION['settings']['date_string'])) {
                $date_string = $_SESSION['settings']['date_string'];
            }
            else {
                $date_string = 'F j, g:i a';
            }
            $date = date($date_string, (hm_strtotime($headers['date'])));
        }
        else {
            $date = 'an unknown date';
        }
        if (isset($headers['from'])) {
            $person = $headers['from'];
        }
        else {
            $person = 'an unknown user';
        }
        $message = "On $date $person wrote:".$message;

        /* subject */
        if (isset($headers['subject'])) {
            if (!preg_match("/^re:/i", $headers['subject'])) {
                $subject = "Re: ".$headers['subject'];
            }
            else {
                $subject = $headers['subject'];
            }
        }
        else {
            $subject = 'Re: '.$str[229];
        }

        /* messageid/replyto/etc */
        if (isset($headers['message-id'])) {
            $messid = $headers['message-id'];
        }
        else {
            $messid = '';
        }
        if (isset($headers['in-reply-to'])) {
            $inreplyto = $headers['in-reply-to'];
        }
        else {
            $inreplyto = '';
        }
        if (isset($headers['references'])) {
            $refs = $headers['references'];
        }
        else {
            $refs = '';
        }

        /* try to find the matching from address */
        if (isset($hm_input['list_reply'])) {
            $header_test = hm_get_full_header($imap_stream, $hm_input['uid'], 
                                              false);
        }
        else {
            $header_test = $headers;
        }
        $match = false;
        $fields = array('to', 'cc', 'delivered-to');
        foreach ($fields as $field) {
            if (isset($header_test[$field])) {
                for ($i=0;$i<$_SESSION['settings']['profile_count'];$i++) {
                    if ($_SESSION['profiles'][$i]['from_address'] != '') {
                        $test_addy = $_SESSION['profiles'][$i]['from_address'];
                        if (preg_match("/$test_addy/i", $header_test[$field])) {
                            $match = true;
                            $index = $i;
                            break 2;
                        }
                    }
                }
            }
        }
        $cc = '';

        /* if reply to all is set */
        if (isset($hm_input['all']) && $hm_input['all'] == 1) {
            $string = '';
            if (isset($headers['cc'])) {
                $string .= ' '.$headers['cc'];
            }
            if (isset($headers['to'])) {
                if ($string) {
                    $string .= ', '.$headers['to'];
                }
                else {
                    $string .= $headers['to'];
                }
            }
            $cc_array = hm_parse_address($string);
            $our_ids = array();
            if (isset($_SESSION['profiles'])) {
                foreach ($_SESSION['profiles'] as $array) {
                    if (isset($array['from_address']) && $array['from_address'] != '') {
                        $our_ids[] = strtolower($array['from_address']);
                    }
                }
            }
            $new_cc_array = array();
            foreach ($cc_array as $val) {
                if (!in_array(strtolower($val), $our_ids)) {
                    $cc .= $val.', ';
                }
            } 
            unset($cc_array);
            unset($new_cc_array);
            $cc = rtrim($cc, " ,");
        }
        $bcc = '';
        if (preg_match("/\\\/", $to)) {
            $to = stripslashes($to);
        }
    }

    /* forwarded message */
    elseif (isset($hm_input['forward'])) {
        $all = true;
        if (isset($hm_input['parts'])) {
            $parts_array = array();
            $all = false;
            if (strstr($hm_input['parts'], ',')) {
                $parts_array = explode(',', $hm_input['parts']);
            }
            else {
                $parts_array[] = $hm_input['parts'];
            }
        }
        $result = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], false,
                                       false, true);
        if ((!$all && in_array($result[0], $parts_array)) || $all) {
            $hm_input['part'] = $result[0];
            $charset = 'us-ascii';
            $code_page = array();
            if (isset($result[2][4])) {
                $charset = strtolower($result[2][4]);
                if (isset($_SESSION['charsets'][$charset])) {
                    $code_page = $_SESSION['charsets'][$charset];
                }
            }
            if ($result[1] == "\n\n     ".$str[194]."\n\n") {
                $message_body = '';
            }
            else {
                $message_body = hm_special_chars2($result[1], $charset, $code_page);
            }
            $message_summary = "\n        ------  ".$str[360]."  ------\n";
    
            $headers = hm_get_full_header($imap_stream, $hm_input['uid'], $parent_part);
            if (isset($headers['subject'])) {
                $subject = $headers['subject'];
                $message_summary .= $str[21].': '.$subject."\n";
                $subject = 'Fwd: '.$subject;
            }
            else {
                $message_summary .= $str[21].': '.$subject."\n";
                $subject = 'Fwd: '.$str[229];
            }
            if (isset($headers['to'])) {
                $fto = $headers['to'];
                $message_summary .= $str[25].':      '.$fto."\n";
            }
            if (isset($headers['from'])) {
                $ffrom = $headers['from'];
                $message_summary .= $str[22].':    '.$ffrom."\n";
            }
            if (isset($headers['date'])) {
                $message_summary .= $str[23].':    '.hm_htmlize($headers['date'])."\n";
            }
            $message = $message_summary."\n".$message_body;
            $cc = '';
            $bcc = '';
            $to = '';
            $refs = '';
            $messid = '';
            $inreplyto = '';
        }
        else {
            $message = '';
            $subject = '';
            $cc = '';
            $bcc = '';
            $to = '';
            $refs = '';
            $messid = '';
            $inreplyto = '';
        }
        if ($all) {
            $parts_array = false;
        }
        hm_format_attached($imap_stream, $structure, $hm_input['part'],
                           $hm_input['uid'], $parts_array);
    }
    
    /* resuming a draft */
    elseif (isset($hm_input['draft'])) {
        $result = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'],
                                        false, false, true);
        $charset = 'us-ascii';
        $code_page = array();
        if (isset($result[2][4])) {
            $charset = strtolower($result[2][4]);
            if (isset($_SESSION['charsets'][$charset])) {
                $code_page = $_SESSION['charsets'][$charset];
            }
        }
        $message = hm_special_chars2($result[1], $charset, $code_page);
        $headers = hm_get_full_header($imap_stream, $hm_input['uid'], $parent_part);
        if (isset($headers['subject'])) {
            $subject = $headers['subject'];
        }
        else {
            $subject = '';
        }
        if (isset($headers['to'])) {
            $to = $headers['to'];
        }
        else {
            $to = '';
        }
        if (isset($headers['cc'])) {
            $cc = $headers['cc'];
        }
        else {
            $cc = '';
        }
        if (isset($headers['from'])) {
            $match = false;
            for ($i=0;$i<$_SESSION['settings']['profile_count'];$i++) {
                if (isset($_SESSION['profiles'][$i]['from_address'])) {
                    $test_addy = $_SESSION['profiles'][$i]['from_address'];
                    if (preg_match("/$test_addy/", $headers['from'])) {
                        $match = true;
                        $index = $i;
                        break;
                    }
                }
            }
        }
        if (count($structure) > 1) {
            hm_format_attached($imap_stream, $structure, $hm_input['part'],
                                $hm_input['uid']);
        }
        $bcc = '';
        $refs = '';
        $messid = '';
        $inreplyto = '';
        $hm_input['draft_id'] = $hm_input['uid'];
    }

    /* send fake message bounce */
    elseif (isset($hm_input['bounce'])) {
        function decode($string) {
            $string = strtr($string, 
                array_flip(get_html_translation_table(HTML_ENTITIES)));
            $string = preg_replace("/&#([0-9]+);/me", "chr('\\1')", $string);
            return $string;
        }
        $bail = false;
        $headers = hm_get_full_header($imap_stream, $hm_input['uid'], $parent_part);
        $to = false;
        if (isset($headers['reply-to'])) {
            $to = stripslashes(decode($headers['reply-to']));
        }
        elseif (isset($headers['from'])) {
            $to = stripslashes(decode($headers['from']));
        }
        else {
            $bail = true;
        }
        if (!isset($headers['subject'])) {
            $subj = '';
        }
        else {
            $subj = decode($headers['subject']);
        }
        if (!isset($headers['date'])) {
            $dat = '';
        }
        else {
            $dat = $headers['date'];
        }
        if (!isset($headers['to'])) {
            $sender = '';
        }
        else {
            $sender = decode($headers['to']);
        }
        if ($sender != '') {
            $domain = substr(strstr($sender, '@'), 1);
        }
        else {
            $domain = $config['domain'];
        }
        $message = "\nThis is an automated message from the  SMTP server at ".
                   $domain."\n".
                   "Your message could not be delivered due to permanent errors:\n".
                   '  550 unknown user '.$sender."\n\nMessage summary:\n".
                   "  Subject: ".$subj."\n  Date: ".$dat."\n  From: ".$to."\n".
                   "  To: ".$sender."\n";
        $cc = '';
        $bcc = '';
        $subject = 'failure notice';
        $messid = '' ;
        $inreplyto = '';
        $refs = '';
        $reply = false;
        $from = 'MAILER-DAEMON@'.$domain;
        if (!$bail) {
            if (!hm_send_mail($to, $cc, $bcc, $subject, $message, $from, $inreplyto,
                              $messid, $refs, $reply, $config, $config_file, true,
                              $version, $hasty_key, $imap_stream, false, false, false,
                              false, true)) {
                $bounce = 'no';
            }
            else {
                $bounce = 'yes';
            }
            header('Location: '.$_SESSION['config']['hostname'].
                   $_SESSION['config']['install_path'].
                   'message.php?uid='.$hm_input['uid'].
                   '&id='.$hm_input['id'].
                   '&bounce_notice='.$bounce.
                   '&mailbox='.$hm_input['mailbox']);
            exit;
        }
        else {
            header('Location: '.$_SESSION['config']['hostname'].
                   $_SESSION['config']['install_path'].
                   'message.php?uid='.$hm_input['uid'].
                   '&id='.$hm_input['id'].
                   '&bounce_notice=no'.
                   '&mailbox='.$hm_input['mailbox']);
            exit;
        }
    }
}

/* blank form */
else {
    if (isset($hm_input['to'])) {
        $to = hm_htmlize($hm_input['to']);
    }
    else {
        $to = '';
    }
    $cc = '';
    $bcc = '';
    $subject = '';
    $message = '';
    $messid = '' ;
    $inreplyto = '';
    $refs = '';
}

/* check for from addresses set in the user settings */
$emtpy = true;
if (isset($_SESSION['profiles'][0]['from_address']) &&
    $_SESSION['profiles'][0]['from_address'] != '') {
    $emtpy = false;
}

/* If 'Send' was clicked */
if (isset($hm_input['send'])) {
    if ($hm_input['to'] == '' && $hm_input['cc'] == '' && $hm_input['bcc'] == '') {
     $_SESSION['notices'][] = $str[167];
        $to = '';
        $cc = '';   
        $bcc = '';   
        $subject =  hm_htmlize($hm_input['subject']);
        $message =  $hm_input['message'];
    }
    else {
        $args = array('no_save' => 'no_save', 'reply_send' => 'reply', 'kan' => 'unread',
                      'rq_dsn' => 'dsn', 'rq_mdn' => 'mdn', 'ean' => 'ean', 'preformat'
                       => 'preformat');
        foreach ($args as $key => $val) {
            if (isset($hm_input[$key])) {
                $$val = true;
            }
            else {
                $$val = false;
            }
        }
        if (isset($hm_input['draft_id'])) {
            $draft = $hm_input['draft_id'];
        }
        else {
            $draft = false;
        }
        if (!hm_send_mail($hm_input['to'], $hm_input['cc'], $hm_input['bcc'], 
                          $hm_input['subject'], $hm_input['message'],
                          $hm_input['from'], $hm_input['inreplyto'],
                          $hm_input['messid'], $hm_input['refs'], $reply, $config,
                          $config_file, false, $version, $hasty_key, $imap_stream,
                          $no_save, $hm_input['priority'], $mdn, $dsn, false, $draft,
                          $ean, $preformat)) {

            $refs = '';
            $messid = '';
            $inreplyto = '';
            $to =       hm_htmlize($hm_input['to']);
            $cc =       hm_htmlize($hm_input['cc']);
            $bcc =      hm_htmlize($hm_input['bcc']);
            $subject =  hm_htmlize($hm_input['subject']);
            $message =  $hm_input['message'];
            if (isset($hm_input['refs'])) {
                $refs = $hm_input['refs'];
            }
            if (isset($hm_input['messid'])) {
                $messid = $hm_input['messid'];
            }
            if (isset($hm_input['inreplyto'])) {
                $inreplyto = $hm_input['inreplyto'];
            }
            if (isset($hm_input['reply_send'])) {
                $hm_input['reply'] = 1;
            }
        }
        else {
            if (isset($_SESSION['attachments'])) {
                foreach ($_SESSION['attachments'] as $name => $vals) {
                    if (file_exists($_SESSION['config']['settings_dir'].
                                    "attachments/".$name)) {
                        unlink($_SESSION['config']['settings_dir'].
                                "attachments/".$name);
                        clearstatcache();
                    }
                }
                $_SESSION['attachments'] = array();
                unset($_SESSION['attachments']);
            }
            if ($reply) {
                header("Location: ".$_SESSION['config']['hostname'].
                       $_SESSION['config']['install_path'].'mailbox.php?id='.
                       $hm_input['id'].'&mailbox='.$hm_input['mailbox'].'&reply_notice='.
                       $hm_input['uid']);
            }
            else {
                header("Location: ".$_SESSION['config']['hostname'].
                       $_SESSION['config']['install_path']."mailbox.php?id=".
                       $hm_input['id']."&mailbox=".$hm_input['mailbox']);
            }
            exit;
        }
    }
}

/* adding an address from the contact list */
elseif (isset($hm_input['to_add']) || isset($hm_input['cc_add']) ||
        isset($hm_input['bcc_add'])) {
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $added = '';
    if (!empty($hm_input['addresses'])) {
        $hm_input['addresses'] = array_unique($hm_input['addresses']);
        foreach($hm_input['addresses'] as $index) {
            if (isset($contacts[$index])) {
                if ($added != '') {
                    $added .= ', ';
                }
                if ($contacts[$index][2] != '') {
                    $added .= '"'.str_replace('"', '\"', $contacts[$index][2]).'" ';
                }
                $added .= $contacts[$index][1];
            }
        }
        switch (true) {
            case isset($hm_input['to_add']):
                if ($to != '') {
                    $to .= ', ';
                }
                $to .= hm_htmlize(utf8_decode($added));
                break;
            case isset($hm_input['cc_add']):
                if ($cc != '') {
                    $cc .= ', ';
                }
                $cc .= hm_htmlize(utf8_decode($added));
                break;
            case isset($hm_input['bcc_add']):
                if ($bcc != '') {
                    $bcc .= ', ';
                }
                $bcc .= hm_htmlize(utf8_decode($added));
                break;
        }
    }
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];

    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}

/* contacts search */
elseif (isset($hm_input['search']) || isset($hm_input['list'])) {
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];

    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}

/* adding signature */
elseif (isset($hm_input['sig'])) {
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $index = 'no';
    if (isset($hm_input['from'])) {
        for ($i=0;$i<$_SESSION['settings']['profile_count'];$i++) {
            if (isset($_SESSION['profiles'][$i]['from_address']) &&
                $hm_input['from'] == $i) {
                $index = $i;
                break;
            }
        }
    }
    if (is_numeric($index)) {
        $message .= $hm_input['message']
                    ."\n\n".
                    hm_htmlize($_SESSION['profiles'][$index]['sig']);
    }
    else {
        $message =  $hm_input['message'];
    }
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}

/* check spelling */
elseif (isset($hm_input['spell'])) {
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];
    $index = 'no';
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
    if (!function_exists('pspell_new')) {
        $_SESSION['notices'][] = $str[375];
        unset($hm_input['spell']);
    }
}

/* accept spell check */
elseif (isset($hm_input['spell_accept']) || isset($hm_input['spell_dismiss'])) {
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    if (isset($hm_input['spell_accept'])) {
        $message =  hm_htmlize(hm_apply_spellcheck(base64_decode($hm_input['message']), $_POST));
        $subject =  hm_htmlize(hm_apply_spellcheck(base64_decode($hm_input['subject']), $_POST, true));
    }
    else {
        $message = hm_htmlize(base64_decode($hm_input['message']));
        $subject = hm_htmlize(base64_decode($hm_input['subject']));
    }
    $index = 'no';
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}
elseif (isset($hm_input['spell_recheck'])) {
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}
/* saving a draft */
elseif (isset($hm_input['save'])) {
    $from_address = $_SESSION['profiles'][$hm_input['from']]['from_address'];
    if (isset($_SESSION['profiles'][$hm_input['from']]['from_name']) &&
        $_SESSION['profiles'][$hm_input['from']]['from_name'] != '') {
        $from_name = '"'.$_SESSION['profiles'][$hm_input['from']]['from_name'].'"';
    }
    else {
        $from_name = '';
    }
    /* properly format the body text */
    if (hm_special_char_check($hm_input['message'])) {
        $content_charset = $str['charset'];
    }
    else {
        $content_charset = 'us-ascii';
    }
    if (hm_special_char_check($hm_input['subject'])) {
        $subject = '=?'.$str['charset'].'?B?'.base64_encode($hm_input['subject']).'?=';
    }
    else {
        $subject = $hm_input['subject'];
    }
    $lines = split("\n", $hm_input['message']);
    $imaplines = array();
    foreach($lines as $string) {
        if (strlen($string) > 78) {
            $imaplines[] = rtrim(implode("\r\n", hm_split_line($string, 76, false, true)),
                           "\n")."\r\n";
        }
        else {
            $imaplines[] = rtrim($string, "\r\n")."\r\n";
        }
    }
    $draft_message  = "Date: ".date("r")."\r\n".
                     "From: $from_name <$from_address>\r\n".
                     "Subject: ".$subject."\r\n".
                     "To: ".$hm_input['to']."\r\n";
    if ($hm_input['cc'] != '') {
        $draft_message .= "Cc: ".$hm_input['cc']."\r\n";
    }
    $draft_message .= "X-Mailer: Hastymail $version\r\n".
                      "MIME-Version: 1.0\r\n".
                      "Content-Type: text/plain; charset=".$content_charset."\r\n\r\n".
                      implode('', $imaplines)."\r\n";
    hm_save_message ($draft_message, $imap_stream, 'draft'); 
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}

/* adding attachments */
elseif (isset($hm_input['attach'])) {
    if (isset($_FILES['attachment']['tmp_name']) &&
        is_uploaded_file($_FILES['attachment']['tmp_name'])) {
        if (!isset($_SESSION['attachments'])) {
            $_SESSION['attachments'] = array();
        }
        $content = '';
        $temp_file_name = md5(uniqid(rand(),1));
        $rawsize = 0;
        if (is_readable($_FILES['attachment']['tmp_name'])) {
            if ($fp_input = fopen($_FILES['attachment']['tmp_name'], "rb")) {
                $fp_output = fopen ($_SESSION['config']['settings_dir'].
                             "attachments/$temp_file_name", 'w');
                while(!feof($fp_input)) {
                    $chunk = fread($fp_input, 24);
                    $new_chunk = base64_encode($chunk)."\r\n";
                    $rawsize += strlen($new_chunk);
                    fputs($fp_output, $new_chunk);
                }
                fclose($fp_input);
                fclose($fp_output);
            }
        }
        if ($rawsize > 0) {
            $_SESSION['attachments'][$temp_file_name] = array( 
                               'name'     => $_FILES['attachment']['name'],
                               'type'     => $_FILES['attachment']['type'],
                               'size'     => $_FILES['attachment']['size'],
                               'rawsize'  => $rawsize,
                               'encoding' => 'base64');        
            if (isset($hm_input['mime_type']) && $hm_input['mime_type'] !=
                'auto') {
                $type = $hm_input['mime_type'];
                $_SESSION['attachments'][$temp_file_name]['type'] = 
                    $hm_input['mime_type'];
            }
            else {
                $type = $_FILES['attachment']['type'];
            }
            if ($_FILES['attachment']['type'] != 'message/digest') {
                $_SESSION['attachments'][$temp_file_name]['header'] =
                "Content-Type: ".$type.
                '; name="'.$_FILES['attachment']['name']."\"\r\n".
                'Content-Disposition: attachment; filename="'.
                $_FILES['attachment']['name']."\"\r\n";
            }
            if (substr($_FILES['attachment']['type'], 
                0, 7) != 'message') {
                $_SESSION['attachments'][$temp_file_name]['header'] .=
                    'Content-Transfer-Encoding: base64'."\r\n\r\n";
            }
        }
        else {            
            $_SESSION['notices'][] = $str[170];
        }
    }
    else {
      $_SESSION['notices'][] = $str[170];
    }
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}
elseif (isset($hm_input['delete'])) {
    if (isset($hm_input['attachment'])) {
        if (file_exists($_SESSION['config']['settings_dir']."attachments/".
                        $hm_input['attachment'])) {
            unlink($_SESSION['config']['settings_dir']."attachments/".
                   $hm_input['attachment']);
            clearstatcache();
        }
        if (isset($_SESSION['attachments'][$hm_input['attachment']])) {
            unset($_SESSION['attachments'][$hm_input['attachment']]);
        }
    }
    $refs = '';
    $messid = '';
    $inreplyto = '';
    $to =       hm_htmlize($hm_input['to']);
    $cc =       hm_htmlize($hm_input['cc']);
    $bcc =      hm_htmlize($hm_input['bcc']);
    $subject =  hm_htmlize($hm_input['subject']);
    $message =  $hm_input['message'];
    if (isset($hm_input['refs'])) {
        $refs = $hm_input['refs'];
    }
    if (isset($hm_input['messid'])) {
        $messid = $hm_input['messid'];
    }
    if (isset($hm_input['inreplyto'])) {
        $inreplyto = $hm_input['inreplyto'];
    }
    if (isset($hm_input['reply_send'])) {
        $hm_input['reply'] = 1;
    }
}

/* no from address then set a default and warn the user */
if ($emtpy) {
    if (strstr($_SESSION['user'], '@')) {
        $_SESSION['profiles'][0]['from_address'] = $_SESSION['user'];
    }
    else {
        $_SESSION['profiles'][0]['from_address'] = $_SESSION['user']."@".
                                                   $config['domain'];
        if (!isset($config['disable_profiles']) || 
            $config['disable_profiles'] != 'true') {
            $_SESSION['notices'][] = $str[168].'<br>'.$str[169].': '.
                                 $_SESSION['profiles'][0]['from_address'];
        }
    }
}

/* check for keep as new setting */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen messages */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* check for missing folders */
hm_check_folders($imap_stream);

/* toolbar */
$page_data = array();
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream, $hm_input['mailbox'],
                                           $unseen, false, $str[15]);

/* preformatted text option */
if (isset($hm_input['preformat']) && $hm_input['preformat']) {
    $page_data['preformat'] = true;
}
else {
    $page_data['preformat'] = false;
}
$page_data['lbl_preformat'] = $str[386];

/* log out of imap */
if (is_resource($imap_stream)) {
    hm_imap_logout($imap_stream);
}

/* compose form */
if (isset($_SESSION['config']['max_file_size']))  {
    $max = $_SESSION['config']['max_file_size'];
}
else {
    $max = '2097152';
}
if (isset($hm_input['no_save']) && $hm_input['no_save'] == 1) {
    $no_save = true;
}
else {
    $no_save = false;
}

$page_data['palm'] = isset($_SESSION['palm']);
$page_data['max_file_size'] = $max;
$page_data['input_refs'] = hm_htmlize($refs);
$page_data['input_message_id'] = hm_htmlize($messid);
$page_data['input_inreplyto'] = hm_htmlize($inreplyto);
$page_data['input_id'] = $hm_input['id'];
$page_data['input_mailbox'] = $hm_input['mailbox'];
if (isset($hm_input['uid'])) {
    $page_data['input_uid'] = $hm_input['uid'];
}
else {
    $page_data['input_uid'] = false;
}
$page_data['input_reply'] = (isset($hm_input['reply']) && $hm_input['reply'] == 1);
$page_data['input_keep_new'] = isset($hm_input['keep_as_new']);
if (isset($hm_input['draft_id'])) {
    $page_data['input_draft_id'] = $hm_input['draft_id'];
}
else {
    $page_data['input_draft_id'] = false;
}
if (isset($hm_input['ean'])) {
    $page_data['ean'] = true;
}
else {
    $page_data['ean'] = false;
}

/* to/cc/bcc/from form elements */
$page_data['lbl_to'] = $str[25];
$page_data['to'] = str_replace('"', '&quot;', $to);
$page_data['lbl_cc'] = $str[87];
$page_data['cc'] = str_replace('"', '&quot;', $cc);
$page_data['lbl_bcc'] = $str[88];
$page_data['bcc'] = str_replace('"', '&quot;', $bcc);
$page_data['lbl_from'] = $str[22];

$profile_options = '';
$page_data['from'] = false;
for($i=0;$i<$_SESSION['settings']['profile_count'];$i++) {
    if (isset($_SESSION['profiles'][$i]['from_address']) && $_SESSION['profiles'][$i]['from_address'] != '') {
        $profile_options .= "                 <option class=\"option2\" ";
        if (isset($match) && $match) {
            if (isset($index) && $index == $i) {
                $page_data['from'] = $i;
                $profile_options .= 'selected="1" ';
            }
        } elseif (isset($hm_input['from'])) {
            if ($hm_input['from'] == $i) {
                $profile_options .= 'selected="1" ';
                $page_data['from'] = $i;
            }
        }
        $profile_options .= "value=\"$i\">";
        if (isset($_SESSION['profiles'][$i]['from_name']) &&
            $_SESSION['profiles'][$i]['from_name'] != '') {
            $profile_options .= "\"".$_SESSION['profiles'][$i]['from_name']."\" ";
        }                      
        $profile_options .= $_SESSION['profiles'][$i]['from_address']."</option>\n";
    }
}
$page_data['profile_options'] = $profile_options;

/* contact list dialog */
$page_data['search_terms'] = $search_terms;
$page_data['lbl_search'] = $str[11];
$page_data['lbl_list_all'] = $str[288];
$page_data['lbl_contacts'] = $str[14];

$page_data['lbl_personal_contacts'] = $str[161];

$personal_contacts = array();
if (count($contacts) > 0) {
    foreach($contacts as $array) {
        if (!isset($array[3])) {
            $array[3] = '';
        }
        $title = hm_htmlize($array[1].'   '.$array[2].'   '.$array[3]); 
        $personal_contacts[$array[0]] = array(hm_htmlize(utf8_decode($array[2])), $title);
    }
}
$page_data['personal_contacts'] = $personal_contacts;


/* priority, MDN request, and skip sent folder options */
$priorities = array (
    1 => '1 - '.$str[321], 
    2 => '2',
    3 => '3 - '.$str[322],  
    4 => '4',
    5 => '5 - '.$str[323]
);

if (!isset($hm_input['priority'])) {
    $hm_input['priority'] = 3;
}
$page_data['priorities'] = $priorities;
$page_data['priority'] = $hm_input['priority'];
$page_data['lbl_compose_options'] = $str[317];
$page_data['lbl_priority'] = $str[318];
$page_data['lbl_request_mdn'] = $str[319];
$page_data['request_mdn'] = isset($hm_input['rq_mdn']);
$page_data['sent_folder'] = (isset($_SESSION['settings']['sent_folder']));
$page_data['lbl_no_save'] = $str[298];
$page_data['no_save'] = (isset($hm_input['no_save']));

/*echo '&nbsp;&nbsp;&nbsp;<input type="checkbox" value="1" ';
    if (isset($hm_input['rq_dsn'])) {
        echo 'CHECKED ';
    }
    echo 'name="rq_dsn">&nbsp;',$str[320];*/

/* subject, send/sign/save buttons and message body section */ 
$page_data['lbl_subject'] = $str[21];
$page_data['subject'] = str_replace('"', '&quot;', $subject);
$page_data['lbl_send'] = $str[162];
$page_data['lbl_sign'] = $str[164];
$page_data['drafts_folder'] = (isset($_SESSION['settings']['drafts_folder']));
$page_data['lbl_save'] = $str[163];
$page_data['lbl_attachments'] = $str[166];
$page_data['message'] = $message;

if (isset($config['enable_spellcheck']) && $config['enable_spellcheck'] == 'true') {
    $page_data['enable_spell'] = true;
}
else {
    $page_data['enable_spell'] = false;
}
$page_data['lbl_spell'] = $str[376];
$page_data['lbl_spell_accept'] = $str[377];
$page_data['lbl_spell_dismiss'] = $str[378];
$page_data['lbl_spell_recheck'] = $str[379];
$page_data['lbl_spell_dicts'] = $str[380];
$page_data['lbl_spell_subject'] = $str[21];
$page_data['lbl_spell_message'] = ucfirst($str[26]);

/* spell check button pushed or recheck from the spellcheck page */
if ((isset($hm_input['spell']) && strlen(trim($message)) > 0)
    || isset($hm_input['spell_recheck'])) {
    $spell = true;
    if (isset($hm_input['spell_recheck'])) {
        $message =  hm_apply_spellcheck(base64_decode($hm_input['message']), 
                    $_POST);
        $subject =  hm_apply_spellcheck(base64_decode($hm_input['subject']), 
                    $_POST, true);
        $page_data['message'] = $message;
        $page_data['subject'] = $subject;
    }
    if (isset($_SESSION['settings']['dictionary'])) {
        $user_dict = $_SESSION['settings']['dictionary'];
    }
    else {
        $user_dict = 'en';
    }
    $page_data['dicts'] = $dicts;
    if (isset($hm_input['dictionary'])) {
        $user_dict = $hm_input['dictionary'];
    }
    $page_data['user_dict'] = $user_dict;
    $page_data['spell_check_message'] = hm_spellcheck($message, $user_dict);
    $page_data['spell_check_subject'] = hm_spellcheck($subject, $user_dict,
                                        true);
    $ems = array(8 => 55, 9 => 56, 10 => 54, 11 => 50, 12 => 50, 13 => 51,
                 14 => 52, 15 => 52, 16 => 53);
    if (isset($_SESSION['settings']['font_size']) &&
        isset($ems[$_SESSION['settings']['font_size']])) {
            $page_data['em'] = $ems[$_SESSION['settings']['font_size']];
    }
    else {
        $page_data['em'] = 50;
    }
}
else {
    $spell =false;
}
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}

/* attachment dialog */
if (isset($_SESSION['attachments']) && count($_SESSION['attachments']) > 0) {
    $total_size = 0;
    $page_data['attachment_dialog'] =  true;
    $page_data['lbl_name'] = $str[93];
    $page_data['lbl_mime'] = $str[44];
    $page_data['lbl_size'] = $str[24];
    
    $attachments = $_SESSION['attachments'];
    foreach($attachments as $index => $array) {
        $total_size += $array['size'];
        $attachments[$index]['html_size'] = hm_size_format($array['size']);
    }
    $page_data['attachments'] = $attachments;
    $page_data['total_size'] = hm_size_format($total_size);
    $page_data['lbl_total_size'] = $str[297];
    
}
else {
    $page_data['attachment_dialog'] = false;
}

$page_data['lbl_attach'] = $str[165];
$page_data['lbl_delete'] = $str[4];
$page_data['lbl_attach_as_type'] = $str[309];

$mime_types = array(
    'auto'                      => $str[306], 
    'text/plain'                => $str[307],
    'application/octet-stream' => $str[308]
);
$page_data['mime_types'] = $mime_types;

/*if (isset($_SESSION['settings']['alt_smtpname']) &&
    $_SESSION['settings']['alt_smtpname'] != '' && isset($config['smtp_auth']) &&
    $config['smtp_auth'] != 'false' && $config['smtp_auth'] != '') {
    if (!isset($_SESSION['alt_spass'])) {
        echo '                  SMTP password:
                <input type="password" class="text2" name="alt_spass"',
            ">\n";
    }
}*/

$page_data['lbl_top'] = $str[324];
if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}
$page_data['start_time'] = $start;

/* output HTTP headers */
hm_output_http_headers();

/* output page */
if ($simple) {
    hm_output_page($page_data, 'compose_template.php', 'simple');
}
elseif ($spell) {
    hm_output_page($page_data, 'spellcheck_template.php', $template_set);
}
else {
    hm_output_page($page_data, 'compose_template.php', $template_set);
}
?>
