<?php

/* folders.php: Page to add/delete IMAP folders
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
* $Id: folders.php,v 1.133 2005/06/13 18:11:55 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'folders');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];
$sort_types = $str['sort_types'];
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}


/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config, 
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* create a new folder */
if (isset($hm_input['create'])) {
    if ($hm_input['newfolder'] != '') {
        if (!isset($hm_input['allow_subs'])) {
            $hm_input['allow_subs'] = 'no';
        }
        if (isset($config['utf7_decode'])) {
            $hm_input['newfolder'] = imap_utf7_encode(utf8_decode(
                                     $hm_input['newfolder']));
        }
        $result = hm_create_folder($hm_input['newfolder'], $imap_stream, 
                                   $hm_input['parent'], $hm_input['allow_subs']);
        $_SESSION['folders'] = hm_boxlist($imap_stream);
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
        
        /* autocreate namespace entry if need be */
        if ($result == $str[208] && $hm_input['parent'] == '' &&
            isset($config['allow_root_folders']) && $hm_input['allow_subs'] == 'yes' &&
            $config['allow_root_folders'] == 'true' && !in_array($hm_input['newfolder'],
            $_SESSION['folders'])) {
            $_SESSION['settings']['namespace'][] = $hm_input['newfolder'];
            $_SESSION['folders'] = hm_boxlist($imap_stream);
            $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
            if (!isset($_SESSION['no_ns_add'])) {
                hmw_write_settings($_SESSION['user'], $config);
                $result = $str[357];
            }
            else {
                unset($_SESSION['no_ns_add']);
            }
        }
        $_SESSION['notices'][] = $result;
        if (isset($config['utf7_decode'])) {
            $hm_input['newfolder'] = imap_utf7_encode(utf8_decode(
                                     $hm_input['newfolder']));
        }
    }
}

/* delete a folder */
elseif (isset($hm_input['delete'])) {
    $box_list = hm_boxlist($imap_stream, false, 'all');
    $subs = false;
    $sub_list = '';
    $delim = $_SESSION['delimiter'];
    foreach ($box_list as $box) {
        if ($box != $hm_input['delfolder'] && substr($box, 0, 
            strlen($hm_input['delfolder'].$delim)) 
                    == $hm_input['delfolder'].$delim) {
            $sub_list = "$box<br>";
            $subs = true;
        }
    }
    if (!$subs) {
        /* get unseen messages */
        $unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

        /* toolbar */
        $page_data = array();
        if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
            $page_data['notices'] = $_SESSION['notices'];
            $_SESSION['notices'] = array();
        }
        else {
            $page_data['notices'] = false;
        }
        list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream,
                                $hm_input['mailbox'], $unseen, false, $str[13]);
        $specials = array('default_folder', 'sent_folder', 'trash_folder',
                          'drafts_folder');
        $warn = '';
        foreach ($specials as $val) {
            if (isset($_SESSION['settings'][$val]) && $_SESSION['settings'][$val] ==
                urlencode($hm_input['delfolder'])) {
                switch ($val) {
                    case 'sent_folder':
                        $warn .= $str[135];
                        break;
                    case 'trash_folder':
                        $warn .= $str[136];
                        break;
                    case 'drafts_folder':
                        $warn .= $str[372];
                        break;
                    case 'default_folder':
                        $warn .= $str[373];
                        break;
                }
            }
        }
        /* add a check for drafts folder deletion here */
        $page_data['nn4'] = isset($_SESSION['nn4_warning']);
        $page_data['input_id'] = $hm_input['id'];
        $page_data['input_mailbox'] = $hm_input['mailbox'];
        $page_data['lbl_delete_warning'] = $str[137];
        $page_data['lbl_delete_confirm_long'] = $str[138];
        $page_data['lbl_delete_confirm'] = $str[139];
        $page_data['warning'] = $warn;
        $page_data['folder_name'] = (isset($config['utf7_decode']) ?
                                    utf8_encode(imap_utf7_decode($hm_input['delfolder'])) 
                                    : $hm_input['delfolder']);
        $page_data['input_delfolder'] = $hm_input['delfolder'];

        /* output HTTP headers */
        hm_output_http_headers();

        /* output page */
        hm_output_page($page_data, 'folder_delete_template.php', 'default');

        exit;
    }
    else {
        $_SESSION['notices'][] = '['.$hm_input['delfolder'].']'.
                                 $str[243].':<br>'.$sub_list;
    }
}

/* confirmed delete folder */
elseif (isset($hm_input['confirm_del'])) {
    $_SESSION['notices'][] =  hm_delete_folder($hm_input['delfolder'], 
                                               $imap_stream, $config['settings_dir']);
    $_SESSION['folders'] = hm_boxlist($imap_stream);
    $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    hm_check_folders($imap_stream, true);
}
elseif (isset($hm_input['rename'])) {
    if (isset($hm_input['rename_new']) && trim($hm_input['rename_new']) != '') {
        $_SESSION['notices'][] = hm_rename_folder($hm_input['rename_folder'], 
                                   $imap_stream, trim($hm_input['rename_new']), 
                                   $config['settings_dir']);
    }
    $_SESSION['folders'] = hm_boxlist($imap_stream);
    $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
}
/* add namespace */
elseif (isset($hm_input['add_ns'])) {
    if ($hm_input['ns_name'] != '' && (!isset($_SESSION['settings']['namespace'])
        || !in_array($hm_input['ns_name'], $_SESSION['settings']['namespace']))) {
        $_SESSION['settings']['namespace'][] = $hm_input['ns_name'];
        $_SESSION['folders'] = hm_boxlist($imap_stream);
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
        if (!isset($_SESSION['no_ns_add'])) {
            hmw_write_settings($_SESSION['user'], $config);
            $_SESSION['notices'][] = $str[335];
        }
        else {
            unset($_SESSION['no_ns_add']);
        }
    }
}
/* remove namespace */
elseif (isset($hm_input['del_ns'])) {
    if (isset($hm_input['ns_del_select'])) {
        $names = $_SESSION['settings']['namespace'];
        $new_names = array();
        foreach ($names as $name) {
            if ($name != $hm_input['ns_del_select']) {
                $new_names[] = $name;
            }
        }
        if (empty($new_names)) {
            unset($_SESSION['settings']['namespace']);
        }
        else {
            $_SESSION['settings']['namespace'] = $new_names;
        }
        $_SESSION['folders'] = hm_boxlist($imap_stream);
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
        hmw_write_settings($_SESSION['user'], $config);
        $_SESSION['notices'][] = $str[336];
    }
}
/* update settings */
elseif (isset($hm_input['update'])) {
    $hidden = array();
    $new_mail_folders = array();
    $folded_folders = array();
    $sorts = array();
    $sorts_tmp = array();
    $full_list = hm_boxlist($imap_stream, false, 'all');
    //sort($full_list);
    foreach($_POST as $key => $value) {
        if (substr($key, 0, 5) == 'hide_' && $value == 'on') {
            $hidden[] = $full_list[substr($key, 5)];
        }
        if (substr($key, 0, 5) == 'sort_' && $value != 'ARRIVAL') {
            $sorts[urlencode($full_list[substr($key, 5)])] = $value;
        }
        if (substr($key, 0, 4) == 'new_' && $value == 'on') {
            $new_mail_folders[] = $full_list[substr($key, 4)];
        }
        if (substr($key, 0, 7) == 'folded_' && $value == 'on') {
            $folded_folders[$full_list[substr($key, 7)]] = 1;
        }
    }
    $_SESSION['settings']['folded'] = $folded_folders;
    $_SESSION['default_folded'] = $folded_folders;
    $new_mail_folders = array_diff($new_mail_folders, $hidden);
    $sorts = array_diff($sorts, $hidden);
    if (!empty($sorts)) {
        $_SESSION['settings']['sort'] = $sorts;
    }
    else {
        if (isset($_SESSION['settings']['sort'])) {
            $_SESSION['settings']['sort'] = array();
            unset($_SESSION['settings']['sort']);
        }
    }
    $_SESSION['settings']['new_mail_folders'] = $new_mail_folders;
    if (!empty($hidden)) {
        $_SESSION['settings']['hidden'] = $hidden;
        $_SESSION['folders'] = array_diff($full_list, $hidden);
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    }
    else {
        $_SESSION['settings']['hidden'] = array();
        unset($_SESSION['settings']['hidden']);
        $_SESSION['folders'] = $full_list;
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    }
    hmw_write_settings($_SESSION['user'], $config);
    $_SESSION['sort_data'] = array();
    $_SESSION['notices'][] = $str[118];
}

/* check for keep as new setting */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen messages */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* if the folder list update was selected */
if (isset($hm_input['Update'])) {
    if (isset($_SESSION['missing_folders_flag'])) {
        $_SESSION['missing_folders_flag'] = 0;
        unset($_SESSION['missing_folders_flag']);
    }  
    if (isset($_SESSION['missing_folders'])) {
        $_SESSION['missing_folders'] = array();
        unset($_SESSION['missing_folders']);
    }
    $new = array();
    $modified = array();
    $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');
    $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
}

else {
    /* get updated folder list */
    if (!isset($_SESSION['folders'])) {
        $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
        $new = array();
        $modified = array();
    }
    else {
        $updated_list = hm_boxlist($imap_stream, true, 'all');
        $new = (array_diff($updated_list, $_SESSION['folders']));
        if (isset($_SESSION['missing_folders'])) {
            $modified = $_SESSION['missing_folders'];
        }
        else {
            $modified = array();
        }
    }
}

$page_data = array();
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream,
                        $hm_input['mailbox'], $unseen, false, $str[13]);

$full_list = hm_boxlist($imap_stream, false);
$full_list_dsp = hm_folder_dsp($full_list);

$page_data['nn4'] = isset($_SESSION['nn4_warning']);
$page_data['input_id'] = $hm_input['id'];
$page_data['input_mailbox'] = $hm_input['mailbox'];
$page_data['lbl_update'] = $str[61];
$delim = $_SESSION['delimiter'];
$page_data['delimiter'] = $delim;
if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}

/* if the folder list needs to be updated */
if (!empty($new) || !empty($modified)) {
    $page_data['new_mod_folders'] = true;
    $page_data['lbl_folder_list_changed'] = $str[244];
    $page_data['lbl_new_folders'] = $str[245];
    $page_data['lbl_mod_folders'] = $str[140];
        
    $page_data['new_folders'] = $new;
    $page_data['mod_folders'] = $modified;
}

/* folder options form */
else {
    $page_data['new_mod_folders'] = false;
    $page_data['lbl_create_delete_folders'] = $str[121];
    $page_data['lbl_create_folder' ] = $str[123];
    $page_data['lbl_create'] = $str[132];
    $page_data['lbl_folder_will_contain'] = $str[124];
    $page_data['lbl_subfolders'] = $str[125];
    $page_data['lbl_mail'] = $str[126];
    $can_have_subs = hm_boxlist ($imap_stream, false, 'can_have_kids');
    $can_have_subs_dsp = hm_folder_dsp($can_have_subs);
    $page_data['lbl_place_folder_in'] = $str[127];
    
    # folder options
    $folder_options = "      <option value=\"\">".$str[141]."</option>\n";
    $folder_options .= implode('', hm_folder_options2('', false, $simple, false, '',
                               $can_have_subs));
    $page_data['folder_options'] = $folder_options;
    $page_data['lbl_delete_folder'] = $str[128];
    $del_list = hm_boxlist ($imap_stream, false, 'all');
    array_shift($del_list);
    if (isset($_SESSION['settings']['namespace'])) {
        $del_list = array_diff($del_list, $_SESSION['settings']['namespace']);
    }
    $page_data['delete_folder_options'] = implode('', hm_folder_options2('', false,
                                          $simple, false, '', $del_list, true));
    
    $page_data['lbl_delete'] = $str[4];
    $page_data['lbl_rename_folder'] = $str[240];
    
    $page_data['rename_folder_options'] = implode('', hm_folder_options2('', false,
                                          $simple, false, '', $del_list, true));
    
    $page_data['lbl_rename'] = $str[239];
    $page_data['lbl_add_namespace'] = $str[337];
    $page_data['lbl_add'] = $str[43];
    if (isset($_SESSION['settings']['namespace'])) {
        $page_data['namespace'] = $_SESSION['settings']['namespace'];
    }
    else {
        $page_data['namespace'] = false;
    }
    $page_data['lbl_selected_namespace'] = $str[345];
    $page_data['lbl_remove'] = $str[338];
    if (isset($config['allow_alt_namespace']) &&
        $config['allow_alt_namespace'] == 'true') {
        $page_data['allow_namespace'] = true;
    }
    else {
        $page_data['allow_namespace'] = false;
    }
    
    /* per folder options */
    //sort($full_list);
    if (isset($_SESSION['settings']['hidden'])) {
        $hidden = $_SESSION['settings']['hidden'];
    }
    else {
        $hidden = array();
    }
    if (isset($_SESSION['settings']['sort'])) {
        $sort = $_SESSION['settings']['sort'];
    }
    else {
        $sort = array();
    }
    if (isset($_SESSION['config']['client_sort']) &&
        $_SESSION['config']['client_sort'] == 'true') {
        $sort_types = $str['client_sort_types'];
    }
    
    $page_data['lbl_folder_properties'] = $str[122];
    $page_data['lbl_folder'] = $str[129];
    $page_data['lbl_hide'] = $str[130];
    $page_data['lbl_sort_type'] = $str[131];
    $page_data['lbl_check_unread'] = $str[265];
    $page_data['lbl_folded_state'] = $str[296];
    
    $names = array();
    if (isset($_SESSION['settings']['namespace'])) {
        $names = $_SESSION['settings']['namespace'];
    }
    
    $out_folders = array();
    foreach ($full_list as $key => $folder) {
        $folder_details = array(
            'key' => $key,
            'name' => $folder,
        );
    
        if (in_array($folder, $_SESSION['nosel_folders'])) {
            $nosel = true;
        }
        else {
            $nosel = false;
        }
        $hide_controls = false;
        if (in_array($folder, $hidden)) {
            $hide_controls = true;
        }
        
        $folder_details['hide_controls'] = $hide_controls;
        $folder_details['nosel'] = $nosel;
        
        if (!$simple && substr_count($full_list_dsp[$folder], $delim) > 0 &&
            !in_array($folder, $names)) {
            $pos = strrpos($full_list_dsp[$folder], $delim);
            
            $folder_details['indent_depth'] = $pos;
            $folder_details['indent'] = str_repeat('&nbsp;', $pos);
            
            if (isset($config['utf7_decode'])) {
                $folder_details['display_name'] = utf8_encode(imap_utf7_decode(
                    substr($full_list_dsp[$folder], ($pos + 1))));
            } else {
                $folder_details['display_name'] = substr($full_list_dsp[$folder],
                                                  ($pos + 1));
            }
        }
        else {
            $folder_details['indent'] = false;
            if (isset($config['utf7_decode'])) {
                $folder_details['display_name'] = '&nbsp;&nbsp;'.
                    utf8_encode(imap_utf7_decode($full_list_dsp[$folder]));
            }
            else {
                $folder_details['display_name'] = '&nbsp;&nbsp;'.$full_list_dsp[$folder];
            }
        }
        
        if ($folder != 'INBOX' && !in_array($folder, $names)) {
            $folder_details['cb'] = true;
            $folder_details['cb_locked'] = (isset($config['lock_special_folders']) &&
                $config['lock_special_folders'] == 'true' && 
                isset($_SESSION['special_folders']) &&
                in_array($folder, $_SESSION['special_folders']));
        }
        else {
            $folder_details['cb'] = false;
        } 
        if (!$hide_controls) {
            if (!$nosel) {
                $sort_type_options = '';
                foreach ($sort_types as $index => $value) {
                    $sort_type_options .= "      <option class=\"text2\" ";
                    if (array_key_exists(urlencode($folder), $sort) && 
                        $sort[urlencode($folder)] == $index) {
                        $sort_type_options .= "SELECTED ";
                    }
                    $sort_type_options .= "value=\"".$index."\">".$value."</option>\n";
                }
                $folder_details['sort_type_options'] = $sort_type_options;
            }
            
            $check_fold_state = false;
            if (!in_array($folder, $_SESSION['nosel_folders'])) {
                $folder_details['check_unread_cb'] = 1;
                
                if (isset($_SESSION['settings']['new_mail_folders']) &&
                    in_array($folder, $_SESSION['settings']['new_mail_folders'])) {
                    $check_fold_state = true;
                }
            }
            else {
                $folder_details['check_unread_cb'] = false;
            }
            $folder_details['check_fold_state'] = $check_fold_state;
            $folder_details['folded_cb'] = ($check_fold_state || $folder == 'INBOX');
            $folder_details['folded'] = isset($_SESSION['default_folded'][$folder]) && 
                                        $_SESSION['default_folded'][$folder] == 1;
        }
        
        $out_folders[] = $folder_details;
    }
    $page_data['folder_data'] = $out_folders;
    $page_data['lbl_update_settings'] = $str[103];
    $page_data['lbl_top'] = $str[324];
} 
$page_data['start_time'] = $start;

hm_imap_logout($imap_stream); 

/* output HTTP headers */
hm_output_http_headers();

/* output page */
if ($simple) {
    hm_output_page($page_data, 'folders_template.php', 'simple');
}
else {
    hm_output_page($page_data, 'folders_template.php', $template_set);
}

?>
