<?php

/* redirect.php:  Used to redirect form submissions
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: redirect.php,v 1.65 2005/08/15 17:21:30 sailfrog Exp $
*/

require_once('../lib/session.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, array(), 'redirect');

/* build url to reroute to */
if (isset($hm_input['hostname']) && isset($hm_input['install_path'])) {
    $header_url = $hm_input['hostname'].$hm_input['install_path'];
    $bail = false;
}
else {
    $bail = true;
}
$extra_url_args = '';
$mailbox = false;
if (isset($hm_input['keep_as_new'])) {
    $extra_url_args = '&keep_as_new=1&kan_uid='.$hm_input['uid'].'&kan_folder='.
                      urlencode($hm_input['mailbox']);
}
if (isset($hm_input['view']) || isset($hm_input['forward_sel'])) {
    $message_parts = array();
    foreach ($_POST as $name => $value) {
        if (substr($name, 0, 3) == 'mp_') {
            $message_parts[] = str_replace('_', '.', substr($name, 3));
        }
    }
    $part_value = implode(',', $message_parts);
}
elseif (isset($hm_input['view_all'])) {
    $message_parts = array();
    foreach ($_POST as $name => $value) {
        if (substr($name, 0, 4) == 'hmp_') {
            $message_parts[] = str_replace('_', '.', substr($name, 4));
        }
    }
    $part_value = implode(',', $message_parts);
}
switch (true) {
    /* stale session so log 'em out! */
    case $bail:
        $header_url = 'logout.php?';
        break;

    /* buttons on the toolbar of every page */
    case isset($hm_input['logout']):
        $header_url .= 'logout.php?';
        break;
    case isset($hm_input['folders']):
        $header_url .= 'folders.php?';
        break;
    case isset($hm_input['new']):
        $header_url .= 'new.php?';
        break;
    case isset($hm_input['compose']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&new=1';
        break;
    case isset($hm_input['contacts']):
        $header_url .= 'contacts.php?';
        break;
    case isset($hm_input['search']):
        $header_url .= 'search.php?';
        break;
    case isset($hm_input['options']):
        $header_url .= 'options.php?';
        break;
    case isset($hm_input['new_session']):
        $header_url .= 'mailbox.php?';
        $extra_url_args .= '&new_session=1';
        break;
    case isset($hm_input['go']):
        $header_url .= 'mailbox.php?';
        $mailbox = $hm_input['toolbar_mailbox'];
        break;

    /* buttons on the message view page */
    case isset($hm_input['full_headers']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'].
                           '&full=yes';
        break;
    case isset($hm_input['small_headers']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'].
                           '&full=no';
        break;
    case isset($hm_input['raw_view']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'].
                           '&raw=1';
        break;
    case isset($hm_input['normal_view']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'];
        break;
    case isset($hm_input['thread_view']):
        $header_url .= 'thread_view.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'];
        break;
    case isset($hm_input['print_view']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&pv=1&part='.$hm_input['part'].'&parts='.$hm_input['parts'];
        if (isset($hm_input['raw'])) {
            $extra_url_args .= '&raw=1';
        }
        elseif (isset($hm_input['full'])) {
            $extra_url_args .= '&full=true';
        }
        break;
    case isset($hm_input['nv']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'];
        if (isset($hm_input['raw'])) {
            $extra_url_args .= '&raw=1';
        }
        elseif (isset($hm_input['full'])) {
            $extra_url_args .= '&full=true';
        }
        break;
    case isset($hm_input['view']):
    case isset($hm_input['view_all']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$part_value;
        break;
    case isset($hm_input['folder_view']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&page_num='.$hm_input['page_num'].
                           '&part='.$hm_input['part'].'&parts='.$hm_input['parts'].
                           '&hide_folder_preview=0';
        break;
    case isset($hm_input['center_move']):
        $header_url .= 'mailbox.php?';
        $extra_url_args .= '&uid_move='.$hm_input['uid'].'&move=1&destination='.
                            urlencode($hm_input['destination']);
        break;
    case isset($hm_input['previous_move']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid_move='.$hm_input['uid'].'&uid='.
                           $hm_input['previous_uid_normal'].'&move=1'.'&destination='.
                           urlencode($hm_input['destination']);
        break;
    case isset($hm_input['next_move']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid_move='.$hm_input['uid'].'&uid='.
                           $hm_input['next_uid_normal'].'&move=1'.'&destination='.
                           urlencode($hm_input['destination']);
        break;
    case isset($hm_input['reply']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['part'].
                           '&reply=1';
        break;
    case isset($hm_input['reply_all']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['part'].
                           '&reply=1&all=1';
        break;
    case isset($hm_input['list_reply']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['part'].
                           '&reply=1&list_reply='.urlencode($hm_input['list_reply_to']);
        break;
    case isset($hm_input['forward']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['part'].
                           '&forward=1';
        break;
    case isset($hm_input['forward_sel']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&forward=1&parts='.$part_value;
        break;
    case isset($hm_input['bounce']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&bounce=1&uid='.$hm_input['uid'].'&part='.$hm_input['part'];
        break;
    case isset($hm_input['resume_draft']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&draft=1&uid='.$hm_input['uid'];
        break; 
    case isset($hm_input['edit_as_new']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&draft=1&ean=1&uid='.$hm_input['uid'];
        break; 
    case isset($hm_input['find_response']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&find_response='.$hm_input['message_id'].'&uid='.
                           $hm_input['uid'];
        break; 
    case isset($hm_input['reply_part']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['sub_part'].
                           '&reply=1';
        break;
    case isset($hm_input['reply_part_all']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['sub_part'].
                           '&reply=1&all=1';
        break;
    case isset($hm_input['reply_part_list']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['sub_part'].
                           '&reply=1&list_reply='.$hm_input['list_reply_to'];
        break;
    case isset($hm_input['forward_part']):
        $header_url .= 'compose.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&part='.$hm_input['sub_part'].
                           '&forward=1';
        break;
    case isset($hm_input['previous_normal']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['previous_uid_normal'];
        break;
    case isset($hm_input['next_normal']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['next_uid_normal'];
        break;
    case isset($hm_input['center_normal']):
        $header_url .= 'mailbox.php?';
        $extra_url_args .= '&page_num='.$hm_input['page_num'];
        break; 
    case isset($hm_input['next_delete']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['next_uid_normal'].'&uid_delete='.
                           $hm_input['uid'].'&delete=1';
        if (isset($hm_input['skip_trash'])) {
            $extra_url_args .= '&skip_trash=1';
        }
        break;
    case isset($hm_input['previous_delete']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['previous_uid_normal'].'&uid_delete='.
                           $hm_input['uid'].'&delete=1';
        if (isset($hm_input['skip_trash'])) {
            $extra_url_args .= '&skip_trash=1';
        }
        break;
    case isset($hm_input['center_delete']):
        $header_url .= 'mailbox.php?';
        $extra_url_args .= '&uid_delete='.$hm_input['uid'].'&delete=1';
        if (isset($hm_input['skip_trash'])) {
            $extra_url_args .= '&skip_trash=1';
        }
        break;
    case isset($hm_input['previous_search']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['previous_uid_search'].'&search=1';
        $mailbox = $hm_input['previous_box_search'];
        break;
    case isset($hm_input['next_search']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['next_uid_search'].'&search=1';
        $mailbox = $hm_input['next_box_search'];
        break;
    case isset($hm_input['center_search']):
        $header_url .= 'search.php?';
        break;
    case isset($hm_input['previous_thread']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['previous_uid_thread'].'&thread=1';
        break;
    case isset($hm_input['next_thread']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['next_uid_thread'].'&thread=1';
        break;
    case isset($hm_input['center_thread']):
        $header_url .= 'thread_view.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'];
        break;
    case isset($hm_input['prep']):
        $header_url .= 'contacts.php?';
        $extra_url_args .= '&prep=1&prep_addy='.urlencode($hm_input['prep_addy']).
                           '&from_message='.$hm_input['uid'];
        break;
    case isset($hm_input['redirect']):
        $header_url .= 'message.php?';
        $extra_url_args .= '&uid='.$hm_input['uid'].'&redirect=1&redirect_to='.
                            urlencode($hm_input['redirect_to']).'&redirect_from='.
                            urlencode($hm_input['redirect_from']);
        break;
    /* don't know how we got here so log'em out! */
    default:
        $header_url .= 'logout.php?';
        break;
}
if (!$mailbox) {
    $mailbox = $hm_input['mailbox'];
}

/* add the session_id + current mailbox and go there */
$header_url .= 'id='.$hm_input['id'].'&mailbox='.urlencode($mailbox);
header('Location: '.$header_url.$extra_url_args);
exit;

?>
